
<div class="kivi-widget">
    <div class="container-fluid d-none" id="kivicare-widget-main-content">
        <div class="widget-layout" id="widgetOrders">
            <?php
            $printConfirmPage = isset($_GET['confirm_page']) && !empty($_GET['confirm_page']) ? sanitize_text_field(wp_unslash($_GET['confirm_page'])) : 'off';
            global $post;
            $postid = $post->ID;
            $user_id = get_current_user_id();

            $options = get_option(KIVI_CARE_PREFIX . 'widgetSetting', true);
            if (gettype($options) !== 'boolean') {
                $options = json_decode($options, true);
                $options = $options['list'];
            } else {
                $options = kcDefaultAppointmentWidgetOrder();
            }


            if (is_user_logged_in()) {
                foreach ($options as $key => $option) {
                    if ($option['att_name'] == 'detail-info') {
                        unset($options[$key]);
                    }
                }
            }

            $tempOptions = $options;

            foreach ($tempOptions as $keys => $option) {
                if (!(isKiviCareProActive() && $shortcode_clinic_id == 0)) {
                    if ($option['att_name'] == 'clinic') {
                        unset($tempOptions[$keys]);
                    }
                }
                if ($shortcode_doctor_id_single) {
                    if ($option['att_name'] == 'doctor') {
                        unset($tempOptions[$keys]);
                    }
                }
            }
            //left side order list
            ?>
            <div class="iq-card iq-card-lg iq-bg-primary widget-tabs" style="overflow: hidden;">
                <ul class="tab-list mb-2" id="kivicare-animate-ul">
                    <?php
                    $tempOptions = array_values($tempOptions);
                    foreach ($tempOptions as $key => $option) {
                        $activeClass = $key == 0 ? "active" : "";
                        switch ($option['att_name']) {
                            case 'doctor':
                                $activeClass = $key == 0 || $shortcode_clinic_id != 0 ? "active" : "";
                                break;
                        }
                        ?>
                        <li class="tab-item <?php echo esc_html($activeClass) ?>" data-check="false">
                            <?php
                            require KIVI_CARE_DIR . 'app/baseClasses/bookAppointment/components/' . $option['att_name'] . '/tab.php';
                            ?>
                        </li>
                        <?php
                    }
                    ?>
                </ul>
                <div class="" style="margin-top: auto;">
                    <button id="kivicare_logout_btn"
                            class="iq-button iq-button-secondary w-100 mt-auto <?php echo esc_html(is_user_logged_in() ? '' : 'd-none'); ?>">
                        <?php echo esc_html('Logout'); ?>
                    </button>
                </div>
            </div>
            <div class="widget-pannel alert-relative">
                <span id="kivicare_server_error_msg" class="alert alert-popup alert-danger alert-left error" style="display:none">&nbsp;</span>
                <span id="kivicare_success_msg" class="alert alert-popup alert-success alert-left" style="display:none;"></span>
                <div class="iq-card iq-card-sm tab-content" id="wizard-tab">
                    <?php
                    $woocommerceCondition = false;
                    if (isKiviCareProActive() || isKiviCareTelemedActive() || isKiviCareGoogleMeetActive()) {
                        if (get_option(KIVI_CARE_PREFIX . 'woocommerce_payment') == false || get_option(KIVI_CARE_PREFIX . 'woocommerce_payment') != 'on') {
                            $woocommerceCondition = true;
                        }
                    }
                    $options = array_values($options);
                    foreach ($options as $key => $option) {
                        switch ($option['att_name']) {
                            case 'clinic':
                            case 'doctor':
                            case 'category':
                            case 'detail-info':
                                if ($option['att_name'] === 'clinic') {
                                    $activeClass = isKiviCareProActive() && $key == 0 && $shortcode_clinic_id == 0 ? 'active ' : '';
                                    $footer = kcWidgetFooterContent('kivicare_error_msg_clinic',$activeClass);
                                } elseif ($option['att_name'] === 'doctor') {
                                    $activeClass = (!isKiviCareProActive() || $key == 0 || $shortcode_clinic_id != 0) && !($shortcode_doctor_id_single) ? 'active ' : '';
                                    $footer = kcWidgetFooterContent('kivicare_error_msg_doctor',$activeClass);
                                } elseif ($option['att_name'] === 'category') {
                                    $activeClass = $key == 0 || $shortcode_doctor_id_single ? "active" : "";
                                    $footer = kcWidgetFooterContent('kivicare_error_msg_category',$activeClass);
                                } else{
                                    $activeClass = $key == 0 ? "active" : "";
                                    $footer = kcWidgetFooterContent('kivicare_error_msg_login_register',$activeClass);
                                }
                                ?>
                                <div id="<?php echo esc_html($option['att_name']); ?>"
                                     class="iq-fade iq-tab-pannel <?php echo esc_html($activeClass); ?>">
                                    <form id="<?php echo esc_html($option['att_name'] === 'detail-info' ? 'kiviLoginRegister' : ''); ?>"
                                          action="<?php echo '#' . esc_html(!empty($options[$key + 1]['att_name']) ? $options[$key + 1]['att_name'] : ''); ?>"
                                          data-prev="<?php echo '#' . esc_html(!empty($options[$key - 1]['att_name']) ? $options[$key - 1]['att_name'] : ''); ?>">
                                        <?php
                                        require KIVI_CARE_DIR . "app/baseClasses/bookAppointment/components/" . $option['att_name'] . "/tab-panel.php";
                                        echo $footer;
                                        ?>
                                    </form>
                                </div>
                                <?php
                                break;
                            case 'date-time':
                                $activeClass = $key == 0 ? "active" : "";
                                $footer = kcWidgetFooterContent('kivicare_error_msg_date_time',$activeClass);
                                $temp = !empty($options[$key + 1]['att_name']) ? $options[$key + 1]['att_name'] : '';
                                ?>
                                <div id="<?php echo esc_html($option['att_name']); ?>"
                                     class="iq-fade iq-tab-pannel <?php echo esc_html($activeClass) ?>">
                                    <form action="<?php echo esc_html(kcCheckExtraTabConditionInAppointmentWidget('all') ? '#file-uploads-custom' : '#' . $temp); ?>"
                                          data-prev="<?php echo '#' . esc_html(!empty($options[$key - 1]['att_name']) ? $options[$key - 1]['att_name'] : ''); ?>">
                                        <?php
                                        require KIVI_CARE_DIR . "app/baseClasses/bookAppointment/components/" . $option['att_name'] . "/tab-panel.php";
                                        echo $footer;
                                        ?>
                                    </form>
                                </div>
                                <?php if (kcCheckExtraTabConditionInAppointmentWidget('all')) {
                                $footer = kcWidgetFooterContent('kivicare_error_msg','');
                                ?>
                                <div id="file-uploads-custom"
                                     class="iq-fade iq-tab-pannel">
                                    <form id="kivicare-file-upload-form" enctype="multipart/form-data"
                                          action="<?php echo '#' . esc_html(!empty($options[$key + 1]['att_name']) ? $options[$key + 1]['att_name'] : ''); ?>"
                                          data-prev="#date-time">
                                        <?php
                                        require KIVI_CARE_DIR . "app/baseClasses/bookAppointment/components/file-upload-custom/tab-panel.php";
                                        echo $footer;
                                        ?>
                                    </form>
                                </div>
                                <?php
                            }
                                break;
                            case 'confirm':
                                $footer = kcWidgetFooterContent('kivicare_error_msg_confirm','');
                                ?>
                                <div id="<?php echo esc_html($option['att_name']); ?>" class="iq-fade iq-tab-pannel">
                                    <form id="confirm_detail_form" action="<?php echo esc_html($woocommerceCondition ? '#confirmed' : ''); ?>"
                                          data-prev="#clinic">
                                        <?php
                                        require KIVI_CARE_DIR . "app/baseClasses/bookAppointment/components/" . $option['att_name'] . "/tab-panel.php";
                                        echo $footer;
                                        ?>
                                    </form>
                                </div>
                                <div id="confirmed" class="iq-fade iq-tab-pannel">
                                    <?php
                                    require KIVI_CARE_DIR . "app/baseClasses/bookAppointment/components/confirmed.php";
                                    ?>
                                </div>
                                <?php
                                break;
                        }
                    }
                    ?>
                </div>
            </div>
        </div>
    </div>
    <span id="kivicare-main-page-loader" style="background:#fff; display: flex;align-items: center;justify-content: center;">
           <?php if (isLoaderCustomUrl()) { ?>
               <img src="<?php echo esc_url(kcAppointmentWidgetLoader()); ?>">
           <?php } else { ?>
               <div class="double-lines-spinner"></div>
           <?php } ?>
    </span>
</div>


<script>
    <?php
    $widgetSetting = json_decode( get_option(KIVI_CARE_PREFIX.'widgetSetting'),true );
    ?>
    if('<?php echo !empty($widgetSetting['primaryColor']);?>'){
        document.documentElement.style.setProperty("--iq-primary", '<?php echo esc_js( !empty($widgetSetting['primaryColor']) ? $widgetSetting['primaryColor'] : '#7093e5' );?>');
    }

    if('<?php echo !empty($widgetSetting['primaryHoverColor']);?>'){
        document.documentElement.style.setProperty("--iq-primary-dark", '<?php echo esc_js( !empty($widgetSetting['primaryHoverColor']) ? $widgetSetting['primaryHoverColor'] : '#4367b9' );?>');
    }

    if('<?php echo !empty($widgetSetting['secondaryColor']);?>'){
        document.documentElement.style.setProperty("--iq-secondary", '<?php echo esc_js(!empty($widgetSetting['secondaryColor']) ?  $widgetSetting['secondaryColor'] : '#f68685' );?>');
    }

    if('<?php echo !empty($widgetSetting['secondaryHoverColor']);?>'){
        document.documentElement.style.setProperty("--iq-secondary-dark", '<?php echo esc_js( !empty($widgetSetting['secondaryHoverColor']) ? $widgetSetting['secondaryHoverColor'] : '#df504e' );?>');
    }
    document.addEventListener('readystatechange', event => {
        if (event.target.readyState === "complete") {
            'use strict';
            (function ($) {
                $('#kivicare-widget-main-content').removeClass('d-none');
                $('#kivicare-main-page-loader').addClass('d-none');
                if (window.matchMedia('(max-width: 768px)').matches) {
                    $('.kivi-widget').css('padding','8px');
                } else {
                    $('.kivi-widget').css('padding','16px');
                }
                const post = (route, data = {}, frontEnd = false, headers = {
                    headers: {'Content-Type': 'application/json'}
                }) => {

                    if (frontEnd) {
                        window.ajaxurl = '<?php echo esc_url(admin_url('admin-ajax.php'));?>';
                        window.nonce = '<?php echo esc_js(wp_create_nonce('ajax_post'));?>';
                    }

                    let url = ajaxurl;
                    if (data.action === undefined) {
                        url = ajaxurl + '?action=ajax_post';
                    }

                    if (route === undefined) {
                        return false
                    }

                    if (data.append !== undefined) {
                        data.append('route_name', route);
                        data.append('_ajax_nonce', nonce)
                    } else {
                        data.route_name = route;
                        data._ajax_nonce = nonce;
                    }

                    return new Promise((resolve, reject, headers) => {
                        axios.post(url, data, headers)
                            .then((data) => {
                                if (data.data.status_code !== undefined && data.data.status_code === 403) {
                                    kivicareShowErrorMessage('kivicare_server_error_msg','<?php echo esc_html__("Route not found","kc-lang"); ?>');
                                }
                                resolve(data)
                            })
                            .catch((error) => {
                                reject(error)
                                kivicareShowErrorMessage('kivicare_server_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                            });
                    })
                }

                const get = (route, data, frontEnd = false) => {

                    if (frontEnd) {
                        window.ajaxurl = '<?php echo esc_url(admin_url('admin-ajax.php'));?>';
                        window.nonce = '<?php echo esc_js(wp_create_nonce('ajax_get'));?>';
                    }

                    let url = ajaxurl;
                    if (data.action === undefined) {
                        url = ajaxurl + '?action=ajax_get';
                    }

                    if (route === undefined) {
                        return false
                    }

                    url = url + '&route_name=' + route;
                    return new Promise((resolve, reject) => {
                        axios.get(url, {params: data})
                            .then((data) => {
                                if (data.data.status_code !== undefined && data.data.status_code === 403) {
                                    kivicareShowErrorMessage('kivicare_server_error_msg','<?php echo esc_html__("Route not found","kc-lang"); ?>');
                                }
                                resolve(data)
                            })
                            .catch((error) => {
                                reject(error)
                                kivicareShowErrorMessage('kivicare_server_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                            });
                    })
                }

                kivicareLoadConfirmPage('<?php echo esc_js($printConfirmPage); ?>');

                var appointmentUploadFiles = [];

                var appointment_custom_fields = { };

                var appointmentDate = '';

                if('<?php echo esc_js( isKiviCareProActive()  && $shortcode_clinic_id == 0); ?>'){
                    getClinicDetailAppointment('', '')
                }

                $(document).on('click', '#kivicare_logout_btn', function () {
                    let logoutElement = $("#kivicare_logout_btn");
                    logoutElement.prop('disabled', true);
                    logoutElement.html('<?php echo esc_html__('Loading....','kc-lang'); ?>');
                    post('logout', {}).then((response) => {
                        if (response.data.status !== undefined && response.data.status === true) {
                            setTimeout(function(){
                                location.reload();
                            }, 1000);
                        }else{
                            logoutElement.prop('disabled', false);
                            logoutElement.html('<?php echo esc_html__('Logout','kc-lang'); ?>');
                        }
                    }).catch((error) => {
                        logoutElement.prop('disabled', false);
                        logoutElement.html('<?php echo esc_html__('Logout','kc-lang'); ?>');
                        kivicareShowErrorMessage('kivicare_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                    })
                })

                getClinicSelectedDetails('<?php echo esc_js(kcGetDefaultClinicId());?>', '', '', 'doctor')

                if('<?php echo esc_js($shortcode_doctor_id_single); ?>'){
                    serviceList(kivicareGetSelectedItem('selected-doctor'), '', 'phpWidget')
                }

                $(document).on('click', '[data-toggle="active"]', function () {
                    $(this).toggleClass('active');
                })

                $("#clinicSearch").keyup(function () {
                    getClinicDetailAppointment('', this.value)
                });

                $("#doctorSearch").keyup(function () {
                    getClinicSelectedDetails(kivicareGetSelectedItem('selected-clinic'), '', this.value, 'doctor')
                });

                $("#serviceSearch").keyup(function () {
                    serviceList(kivicareGetSelectedItem('selected-doctor'), this.value, 'phpWidget')
                });

                $(document).on('click', '[data-step="next"]', function (e) {
                    var target = $(this).closest('form').attr('action');
                    removeTabActiveLink($(`[href="${target}"]`).closest('.tab-item'));
                    var currentTab = $(this).closest('form').closest('.iq-tab-pannel').attr('id')
                    switch (currentTab){
                        case 'clinic':
                            e.preventDefault();
                            var selected_clinic = kivicareGetSelectedItem('selected-clinic');
                            if (selected_clinic == 0) {
                                kivicareShowErrorMessage('kivicare_error_msg_clinic','<?php echo esc_html__('Select Clinic', 'kc-lang') ?>');
                                return;
                            }else{
                                if (target == '#doctor') {
                                    getClinicSelectedDetails(selected_clinic, '', '', 'doctor')
                                } else if (target == '#category') {
                                    getClinicSelectedDetails(selected_clinic, '', '', 'category')
                                }
                            }
                            break;
                        case 'doctor':
                            e.preventDefault();
                            var selected_doctor =  kivicareGetSelectedItem('selected-doctor');
                            if (selected_doctor == 0) {
                                kivicareShowErrorMessage('kivicare_error_msg_doctor','<?php echo esc_html__('Select Doctor', 'kc-lang') ?>');
                                return;
                            }else{
                                if (target == '#category' ) {
                                    serviceList(selected_doctor, '', 'phpWidget')
                                } else if (target == '#clinic') {
                                    getClinicDetailAppointment(selected_doctor, '')
                                }
                            }
                            break;
                        case 'category':
                            e.preventDefault();
                            var name = $('.selected-service');
                            var selected = 0;
                            var selected_service = [];
                            for (var i = 0; i < name.length; i++) {
                                if (name[i].checked == true) {
                                    selected = selected + 1;
                                    selected_service.push(name[i].value)
                                }
                            }
                            if (selected == 0) {
                                kivicareShowErrorMessage('kivicare_error_msg_category','<?php echo esc_html__('Select Category', 'kc-lang') ?>');
                                return;
                            }else{
                                if (target == '#doctor') {
                                    getClinicSelectedDetails(name[i].attributes.clinic_id.nodeValue, name[i].attributes.doctor_id.nodeValue, '', 'doctor')
                                }else if(target == '#clinic'){

                                }
                            }
                            break;
                        case 'date-time':
                            e.preventDefault();
                            var select_time = kivicareGetSelectedItem('selected-time');
                            if (select_time == 0) {
                                kivicareShowErrorMessage('kivicare_error_msg_date_time','<?php echo esc_html__('Select Date and Time', 'kc-lang') ?>');
                                return;
                            }
                            break;
                        case 'file-uploads-custom':
                            $('#customFieldsListAppointment .kivicare-required').prop('required',true);
                            $.each( $('#customFieldsListAppointment').find(':input:checkbox').parent().parent(), function(key,value) {
                                let cbx_group = $(value).find(':input:checkbox');
                                if(cbx_group.is(":checked")){
                                    cbx_group.prop('required', false);
                                }
                            });

                            if (!$("#kivicare-file-upload-form")[0].checkValidity()){
                                return
                            }
                            appointment_custom_fields = kivicareCustomFieldsData('customFieldsListAppointment');
                            e.preventDefault();
                            break;
                        case 'detail-info':
                            var formName = document.getElementsByClassName('authActive active')
                            for (var i = 0; i < formName.length; i++) {
                                if (formName[i].id == 'login') {
                                    $('#kivicare-login-form input').prop('required',true);
                                    $('#kivicare-register-form input,textarea, select').prop('required',false);

                                    if (!$("#kiviLoginRegister")[0].checkValidity()){
                                        return
                                    }

                                    var result = { };
                                    $.each($('#kivicare-login :input').serializeArray(), function() {
                                        result[this.name] = this.value;
                                    });
                                    e.preventDefault();
                                    kivicareButtonDisableChangeText('#kiviLoginRegister',true,'<?php echo esc_html__('Loading....','kc-lang');?>')
                                    post('appointmentLogin', result, true)
                                        .then((response) => {
                                            kivicareButtonDisableChangeText('#kiviLoginRegister',false,'<?php echo esc_html__('Login','kc-lang');?>');
                                            if (response.data.status) {
                                                $("#kivicare_logout_btn").removeClass('d-none');
                                                kivicareShowErrorMessage('kivicare_success_msg',response.data.message);
                                                showConfirmPage(target, currentTab)
                                                $(`[href="#${currentTab}"]`).closest('.tab-item').attr('data-check', true)
                                                $(`[href="${target}"]`).closest('.tab-item').addClass('active')
                                                tabShow(target);

                                            } else {
                                                kivicareShowErrorMessage('kivicare_error_msg_login_register',response.data.message);
                                            }
                                        }).catch((error) => {
                                        kivicareButtonDisableChangeText('#kiviLoginRegister',false,'<?php echo esc_html__('Login','kc-lang');?>')
                                        console.log(error);
                                        kivicareShowErrorMessage('kivicare_error_msg_login_register','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                                    })
                                }
                                if (formName[i].id == 'register') {
                                    $('#kivicare-login-form input').prop('required',false);
                                    $('#kivicare-register input').prop('required',true);
                                    $('#customFieldsList .kivicare-required').prop('required',true);
                                    $.each( $('#customFieldsList').find(':input:checkbox').parent().parent(), function(key,value) {
                                        let cbx_group = $(value).find(':input:checkbox');
                                        if(cbx_group.is(":checked")){
                                            cbx_group.prop('required', false);
                                        }
                                    });

                                    if (!$("#kiviLoginRegister")[0].checkValidity()){
                                        return
                                    }

                                    var result = { };
                                    $.each($('#kivicare-register :input').serializeArray(), function() {
                                        result[this.name] = this.value;
                                    });

                                    var register_form_custom_field = kivicareCustomFieldsData('customFieldsList');
                                    kivicareButtonDisableChangeText('#kiviLoginRegister',true,'<?php echo esc_html__('Loading....','kc-lang');?>')
                                    e.preventDefault();
                                    post('register', {...result,...{register_form_custom_field}}, true)
                                        .then((response) => {
                                            kivicareButtonDisableChangeText('#kiviLoginRegister',false,'<?php echo esc_html__('Register','kc-lang');?>')
                                            if (response.data.status) {
                                                $("#kivicare_logout_btn").removeClass('d-none');
                                                kivicareShowErrorMessage('kivicare_success_msg',response.data.message);
                                                showConfirmPage(target, currentTab)
                                                $(`[href="#${currentTab}"]`).closest('.tab-item').attr('data-check', true)
                                                $(`[href="${target}"]`).closest('.tab-item').addClass('active')
                                                tabShow(target);
                                            }else{
                                                kivicareShowErrorMessage('kivicare_error_msg_login_register',response.data.message);
                                            }
                                        }).catch((error) => {
                                        kivicareButtonDisableChangeText('#kiviLoginRegister',false,'<?php echo esc_html__('Register','kc-lang');?>')
                                        console.log(error);
                                        kivicareShowErrorMessage('kivicare_error_msg_login_register','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                                    })
                                }
                            }
                            return;
                            break;
                        case 'confirm':
                            e.preventDefault();
                            target='';
                            var visit_type_data = [];
                            var name3 = $('.selected-service');
                            var visit_type;
                            for (let i = 0; i < name3.length; i++) {
                                if (name3[i].checked == true) {
                                    visit_type = {
                                        'id': name3[i].value,
                                        'service_id': name3[i].attributes.service_id.nodeValue,
                                    }
                                    visit_type_data.push(visit_type)
                                }
                            }
                            var description = '';
                            if(document.getElementById('appointment-descriptions-field') !== null){
                                description = document.getElementById('appointment-descriptions-field').value
                            }
                            kivicareButtonDisableChangeText('#confirm_detail_form',true,'<?php echo esc_html__('Loading ...','kc-lang');?>');
                            $('#kivi_confirm_page .kivi-col-6').css('opacity','0.5');
                            $('#confirm_loader').removeClass('d-none');
                            post('save_appointment', {
                                appointment_start_date: appointmentDate,
                                appointment_start_time: kivicareGetSelectedItem('selected-time'),
                                visit_type: visit_type_data,
                                patient_id: '<?php echo esc_js(get_current_user_id());?>',
                                doctor_id: {id: kivicareGetSelectedItem('selected-doctor')},
                                clinic_id: {id: kivicareGetSelectedItem('selected-clinic')},
                                status: 1,
                                enableTeleMed: '',
                                file:appointmentUploadFiles,
                                custom_fields:appointment_custom_fields,
                                description:description,
                                widgetType:'phpWidget'
                            })
                                .then((response) => {
                                    kivicareButtonDisableChangeText('#confirm_detail_form',false,'<?php echo esc_html__('Confirm','kc-lang');?>');
                                    $('#kivi_confirm_page .kivi-col-6').css('opacity','');
                                    $('#confirm_loader').addClass('d-none');
                                    if (response.data.status !== undefined && response.data.status === true) {
                                        let checkWoocommerceCart = response.data;
                                        if (checkWoocommerceCart.woocommerce_cart_data !== undefined) {
                                            if(checkWoocommerceCart.woocommerce_cart_data.woocommerce_redirect !== undefined) {
                                                location.href = checkWoocommerceCart.woocommerce_cart_data.woocommerce_redirect ;
                                            }
                                        }else{
                                            kivicarePrintContent(response.data.data.id)
                                            $(`[href="#${currentTab}"]`).closest('.tab-item').attr('data-check', true)
                                            $(`[href="#confirmed"]`).closest('.tab-item').addClass('active')
                                            tabShow('#confirmed');
                                        }
                                    } else {
                                        let message = response.data.message !== undefined ? response.data.message : '<?php echo esc_html__("Internal server error","kc-lang"); ?>';
                                        kivicareShowErrorMessage('kivicare_error_msg_confirm',message);
                                    }
                                }).catch((error) => {
                                kivicareButtonDisableChangeText('#confirm_detail_form',false,'<?php echo esc_html__('Confirm','kc-lang');?>');
                                $('#kivi_confirm_page .kivi-col-6').css('opacity','');
                                $('#confirm_loader').addClass('d-none');
                                console.log(error);
                                kivicareShowErrorMessage('kivicare_error_msg_confirm','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                            });
                            break;
                    }

                    switch(target){
                        case '#confirm':
                            showConfirmPage(target, currentTab);
                            break;
                        case '#file-uploads-custom':
                            if('<?php echo esc_js(isKiviCareProActive()); ?>'){
                                get('get_appointment_custom_field', {doctor_id: kivicareGetSelectedItem('selected-doctor')}, true)
                                    .then((res) => {
                                        if(res.data.status !== undefined && res.data.status){
                                            document.getElementById('customFieldsListAppointment').innerHTML = res.data.data
                                        }
                                    }).catch((error) => {
                                    console.log(error);
                                })
                            }
                            break;
                        case '#date-time':
                            kivicareGetDoctorWeekday(kivicareGetSelectedItem('selected-doctor'));
                            break;
                        case '#confirmed':
                            jQuery('[href="#confirm"]').closest('.tab-item').removeClass('active');
                            break;
                    }

                    $(`[href="#${currentTab}"]`).closest('.tab-item').attr('data-check', true)
                    $(`[href="${target}"]`).closest('.tab-item').addClass('active')
                    if(target != '#confirm'){
                        tabShow(target);
                    }
                })

                $(document).on('click', '[data-step="prev"]', function (e) {
                    e.preventDefault();
                    const target = $(this).closest('form').attr('data-prev');
                    const currentTab = $(this).closest('form').closest('.iq-tab-pannel').attr('id')
                    $(`[href="#${currentTab}"]`).closest('.tab-item').attr('data-check', false)
                    $(`[href="#${currentTab}"]`).closest('.tab-item').removeClass('active')
                    $(`[href="${target}"]`).closest('.tab-item').addClass('active')
                    $(`[href="${target}"]`).closest('.tab-item').attr('data-check', false)
                    if (currentTab == 'confirm') {
                        location.reload()
                    }
                    tabShow(target);
                })

                $(document).on('change', '.selected-service-single', function (e) {
                    if(this.checked) {
                        $(this).closest('form').find('[data-step="next"]').trigger('click');
                    }
                })

                $(document).on('change', '.kivicare-doctor-widget', function (e) {
                    $(this).closest('form').find('[data-step="next"]').trigger('click');
                })

                $(document).on('change', '.selected-time', function (e) {
                    $(this).closest('form').find('[data-step="next"]').trigger('click');
                });

                $(document).on('change', '.selected-clinic', function (e) {
                    $(this).closest('form').find('[data-step="next"]').trigger('click');
                })

                function showConfirmPage(target, currentTab){
                    var name = $('.selected-service');
                    var selectedService = [];
                    var description = '';
                    if(document.getElementById('appointment-descriptions-field') !== null){
                        description = document.getElementById('appointment-descriptions-field').value
                    }
                    
                    for (var i = 0; i < name.length; i++) {
                        if (name[i].checked == true) {
                            selectedService.push(name[i].attributes.service_id.nodeValue)
                        }
                    }
                    setTimeout(() => {
                        post('appointment_confirm_page',{clinic_id:kivicareGetSelectedItem('selected-clinic'),doctor_id:kivicareGetSelectedItem('selected-doctor'),service_list:selectedService,time:kivicareGetSelectedItem('selected-time'),date:appointmentDate,description:description,file:appointmentUploadFiles, custom_field:appointment_custom_fields})
                            .then((response) =>{
                                $('#kivi_confirm_page').removeClass('d-none')
                                $('#confirm_loader').addClass('d-none')
                                if(response.data.status){
                                    document.getElementById('kivi_confirm_page').innerHTML = response.data.data
                                }
                            }).catch((error) => {
                            $('#kivi_confirm_page').removeClass('d-none')
                            $('#confirm_loader').addClass('d-none')
                            console.log(error);
                            kivicareShowErrorMessage('kivicare_error_msg_confirm','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                        })

                        $(`[href="#${currentTab}"]`).closest('.tab-item').attr('data-check', true)
                        $(`[href="${target}"]`).closest('.tab-item').addClass('active')
                        tabShow(target);
                    },1000)
                }

                // Tab script
                $('[data-iq-toggle="tab"]').on('click', function (e) {
                    if($(this).attr('href') === '#login'){
                        $(this).closest('form').find('button[data-step="next"]').html('<?php echo esc_html__('login','kc-lang'); ?>');
                    }
                    if($(this).attr('href') === '#register'){
                        $(this).closest('form').find('button[data-step="next"]').html('<?php echo esc_html__('register','kc-lang'); ?>');
                    }

                    e.preventDefault();
                    const tab_id = $(this).attr('href');
                    if ($(this).attr('data-iq-tab') !== 'prevent') {
                        $(this).closest('.tab-item').find('.tab-link.active').removeClass('active')
                        activeNavItem($(this));
                        tabShow(tab_id);
                        removeTabActiveLink($(this));
                    }
                });

                function tabShow(target) {
                    // if($('.kivi-widget').length > 0 ){
                    //     $('html,body').animate({scrollTop: ($('.kivi-widget').offset().top - 20)+'px'}, 1000);
                    // }
                    $(target).addClass('active').siblings().removeClass('active');
                    const tab = $(target).closest('.tab-content').attr('id');
                    const event = new CustomEvent(`tabShown-${tab}`, {
                        detail: {
                            target: target,
                        },
                    })
                    document.dispatchEvent(event);
                }

                function activeNavItem(navlink) {
                    $(navlink).addClass('active');
                    $(navlink).closest('.tab-item').addClass('active');
                }

                function removeTabActiveLink(target) {
                    $(target).closest('.tab-item').siblings().removeClass('active')
                }

                // Model script
                $(document).on('click', '[data-toggle="modal"]', function () {
                    const target = $(this).data('target');
                    showModal(target);
                })

                function showModal(target) {
                    $('.modal').removeClass('show');
                    $(target).addClass('show');
                    const event = new CustomEvent('modalShown', {
                        detail: {
                            target: target,
                        },
                    })
                    document.dispatchEvent(event);
                }

                function getClinicSelectedDetails(clinic_id_in, doctor_id_in, searchKey_in, nextStep_in){
                    let doctorLists = document.getElementById("doctorLists");
                    doctorLists.classList.remove('card-list');
                    kivicareAddLoader(doctorLists);
                    if('<?php echo esc_js($shortcode_clinic_id != 0); ?>'){
                        clinic_id_in =  '<?php echo esc_js($shortcode_clinic_id); ?>'
                    }
                    get('get_clinic_selected_details', {clinic_id: clinic_id_in, doctor_id: doctor_id_in, searchKey: searchKey_in, nextStep:nextStep_in}, true)
                        .then((res) => {
                            if(nextStep_in == 'doctor' || nextStep_in ==' date-time '){
                                doctorLists.innerHTML = '';
                                if (res.data.status !== undefined && res.data.status) {
                                    doctorLists.classList.add('card-list');
                                    doctorLists.innerHTML = res.data.data;
                                } else {
                                    doctorLists.innerHTML = `<p class="loader-class">  <?php echo esc_html__('No Doctor Available', 'kc-lang');?> </p>`
                                }

                            }else if(nextStep_in == 'category'){

                                let serviceLists = document.getElementById("serviceLists");
                                // serviceLists.classList.add('iq-category-list');
                                serviceLists.innerHTML = '';
                                if (res.data.status !== undefined && res.data.status) {
                                    serviceLists.innerHTML = res.data.data;
                                } else {
                                    serviceLists.innerHTML = `<p class="loader-class">  <?php echo esc_html__('No Service Available', 'kc-lang');?> </p>`
                                }

                            }
                        }).catch((error) => {
                            console.log(error);
                            kivicareShowErrorMessage('kivicare_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                        })
                }

                function getClinicDetailAppointment(doctor_id_in, searchKey_in){
                    let clinicCard = document.getElementById("clinicLists");
                    clinicCard.classList.remove('card-list');
                    kivicareAddLoader(clinicCard);
                    get('get_clinic_details_appointment', {doctor_id: doctor_id_in, searchKey: searchKey_in}, true)
                        .then((res) => {
                            clinicCard.innerHTML = '';
                            if (res.data.status !== undefined && res.data.status) {
                                clinicCard.classList.add('card-list');
                                clinicCard.innerHTML = res.data.data;
                            } else {
                                clinicCard.innerHTML = `<p class="loader-class">  <?php echo esc_html__('No Clinic Available', 'kc-lang');?> </p>`
                            }
                        }).catch((error) => {
                            console.log(error);
                            kivicareShowErrorMessage('kivicare_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                        })
                }

                function serviceList(doctor_id_in, searchKey_in, widgetType_in){
                    let serviceLists = document.getElementById("serviceLists");
                    kivicareAddLoader(serviceLists);
                    get('service_list', {doctor_id: doctor_id_in,searchKey: searchKey_in,widgetType: widgetType_in}, true)
                        .then((res) => {
                            // serviceLists.classList.add('iq-category-list');
                            serviceLists.innerHTML = '';
                            if (res.data.status !== undefined && res.data.status) {
                                serviceLists.innerHTML = res.data.html;
                            } else {
                                serviceLists.innerHTML = `<p class="loader-class"> <?php echo esc_html__('No service Available', 'kc-lang'); ?>  </p>`
                            }
                        }).catch((error) => {
                            console.log(error);
                            kivicareShowErrorMessage('kivicare_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                        })
                }

                function kivicareGetSelectedItem(element){
                    let defaultSelected = 0 ;
                    if( element === 'selected-clinic'){
                        if('<?php echo esc_js($shortcode_clinic_id != 0); ?>'){
                            return '<?php echo esc_js($shortcode_clinic_id); ?>'
                        }
                    }

                    if(element === 'selected-doctor'){
                       if('<?php echo esc_js($shortcode_doctor_id_single); ?>'){
                           return '<?php echo esc_js($shortcode_doctor_id); ?>'
                       }
                    }

                    let tempElement = $('.'+element);
                    if (tempElement.length > 0) {
                        for (let i = 0; i < tempElement.length; i++) {
                            if (tempElement[i].checked == true) {
                                defaultSelected = tempElement[i].value;
                            }
                        }
                    }
                    return defaultSelected;
                }
                function kivicareShowErrorMessage(element,message){
                    document.getElementById(element).style.display = 'block';
                    if(message !== ''){
                        document.getElementById(element).innerHTML = message;
                    }
                    setTimeout(() => {
                        document.getElementById(element).style.display = 'none';
                    }, 3000);
                }

                function kivicareGetDoctorWeekday(id) {
                    $('#doctor-datepicker-loader').removeClass('d-none');
                    $('.doctor-session-error').addClass('d-none');
                    $('.iq-kivi-calendar-slot').addClass('d-none')
                    let selected_clinic = kivicareGetSelectedItem('selected-clinic');
                    let doctorWorkdayajaxData = {
                        clinic_id: selected_clinic,
                        doctor_id: id,
                        type: 'flatpicker'
                    }
                    get('get_doctor_workdays', doctorWorkdayajaxData)
                        .then((response) => {
                            if (response.data.status !== undefined && response.data.status === true) {
                                let restrictionData = <?php echo json_encode(kcAppointmentRestrictionData());?>;
                                let days = response.data.data;
                                if([0,1,2,3,4,5,6].every(r => days.includes(r))){
                                    $('.doctor-session-error').removeClass('d-none');
                                    $('.doctor-session-loader').addClass('d-none');
                                    $('#doctor-datepicker-loader').addClass('d-none');
                                    $('.iq-kivi-calendar-slot').addClass('d-none')
                                }else{
                                    $('.iq-kivi-calendar-slot').removeClass('d-none')
                                    $('.doctor-session-loader').addClass('d-none');
                                    $('.doctor-session-error').addClass('d-none');
                                    $('#doctor-datepicker-loader').addClass('d-none');
                                    flatpickr(".iq-inline-datepicker", {
                                        // Inline flatpicker
                                        inline: true,
                                        minDate:new Date().fp_incr(restrictionData.pre_book),
                                        maxDate:new Date().fp_incr(restrictionData.post_book),
                                        disable: [
                                            function (date) {
                                                return ((days.includes(0) && date.getDay() === 0)
                                                    || (days.includes(1) && date.getDay() === 1)
                                                    || (days.includes(2) && date.getDay() === 2)
                                                    || (days.includes(3) && date.getDay() === 3)
                                                    || (days.includes(4) && date.getDay() === 4)
                                                    || (days.includes(5) && date.getDay() === 5)
                                                    || (days.includes(6) && date.getDay() === 6)
                                                );
                                            }
                                        ],
                                        locale: {
                                            weekdays: {
                                                shorthand: [
                                                    "<?php echo esc_html__('Sun', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Mon', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Tue', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Wed', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Thu', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Fri', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Sat', 'kc-lang'); ?>"
                                                ],
                                                longhand: [
                                                    "<?php echo esc_html__('Sunday', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Monday', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Tuesday', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Wednesday', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Thursday', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Friday', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Saturday', 'kc-lang'); ?>"
                                                ],
                                            },
                                            months: {
                                                shorthand: [
                                                    "<?php echo esc_html__('Jan', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Feb', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Mar', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Apr', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('May', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Jun', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('July', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Aug', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Sep', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Oct', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Nov', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('Dec', 'kc-lang'); ?>"
                                                ],
                                                longhand: [
                                                    "<?php echo esc_html__('January', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('February', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('March', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('April', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('May', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('June', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('July', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('August', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('September', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('October', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('November', 'kc-lang'); ?>",
                                                    "<?php echo esc_html__('December', 'kc-lang'); ?>"
                                                ],
                                            },
                                        },
                                        shorthandCurrentMonth: true,
                                        onChange: function (selectedDates, dateStr, instance) {
                                            let timeSlotListsElement = document.getElementById("timeSlotLists");
                                            timeSlotListsElement.classList.remove('d-grid');
                                            kivicareAddLoader(timeSlotListsElement);
                                            let selected_clinic = kivicareGetSelectedItem('selected-clinic');
                                            let selected_doctor = kivicareGetSelectedItem('selected-doctor');
                                            $('#timeSlotLists').css('height','100%');
                                            $('#timeSlotLists').parent().css('height','400px');
                                            appointmentDate = dateStr;

                                            let timeSlotAjaxData = {
                                                doctor_id: selected_doctor,
                                                clinic_id: selected_clinic,
                                                date: dateStr,
                                                widgetType: 'phpWidget'
                                            }
                                            get('get_time_slots', timeSlotAjaxData)
                                                .then((res) => {
                                                    if (res.data.status !== undefined && res.data.status) {
                                                        $('#timeSlotLists').css('height','');
                                                        $('#timeSlotLists').parent().css('height','');
                                                        timeSlotListsElement.classList.add('d-grid');
                                                        timeSlotListsElement.innerHTML = res.data.html;
                                                    } else if (res.data.status !== undefined && !res.data.status) {
                                                        timeSlotListsElement.innerHTML = `<p class="loader-class">` + res.data.message + `</p>`;
                                                    }

                                                }).catch((error) => {
                                                console.log(error);
                                                kivicareShowErrorMessage('kivicare_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                                            })

                                            $('.iq-inline-datepicker').addClass('d-none')
                                        },
                                    });
                                }
                            }
                        })
                        .catch((error) => {
                            console.log(error);
                            kivicareShowErrorMessage('kivicare_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                        })
                }

                function kivicareAddLoader(ele) {
                    ele.innerHTML = `<span class="loader-class" id="doctor_loader">
                                        <?php  if(isLoaderCustomUrl()){?>
                                            <img src="<?php echo esc_url(kcAppointmentWidgetLoader()); ?>">
                                        
                                        <?php }else{            ?>   
                                            <div class="double-lines-spinner"></div>
                                        <?php } ?>
                                    </span>`
                }

                $(document).on('change', '#kivicareaddMedicalReport', function (e) {
                    document.getElementById('kivicare_file_upload_review').innerHTML = '';
                    appointmentUploadFiles = [];
                    let form_id = document.getElementById('kivicare-file-upload-form')
                    let formData = new FormData(form_id);
                    kivicareButtonDisableChangeText('#kivicare-file-upload-form',true,'<?php echo esc_html__('Uploading.......','kc-lang');?>')
                    post('upload_multiple_report', formData)
                        .then((response) => {
                            kivicareButtonDisableChangeText('#kivicare-file-upload-form',false,'<?php echo esc_html__('Next','kc-lang');?>')
                            if(response.data.status !== undefined && response.data.status === true){
                                if(response.data.data.length > 0) {
                                    kivicareShowErrorMessage('kivicare_success_msg',response.data.message);
                                    appointmentUploadFiles = response.data.data
                                    document.getElementById('kivicare_file_upload_review').innerHTML = response.data.html;
                                }
                            }else{
                                kivicareShowErrorMessage('kivicare_error_msg',response.data.message);
                            }
                        })
                        .catch((error) => {
                            kivicareButtonDisableChangeText('#kivicare-file-upload-form',false,'<?php echo esc_html__('Next','kc-lang');?>')
                            kivicareShowErrorMessage('kivicare_error_msg','<?php echo esc_html__("Internal server error","kc-lang"); ?>');
                        })
                })

                function kivicareButtonDisableChangeText(ele,disableEnable,buttonText){
                    let element = $(ele).find('button[type="submit"]');
                    element.prop('disabled', disableEnable);
                    element.html(buttonText);
                }

                function kivicareLoadConfirmPage(value){
                    if(value !== 'off'){
                        kivicarePrintContent(value);
                        if($('#widgetOrders').length > 0){
                            $('#widgetOrders').find('ul li').each( function (key,value){
                                $(this).removeClass('active')
                                $(this).attr('data-check',true)
                            })
                        }
                        if($('#widgetOrders').length > 0){
                            $('#widgetOrders').find('.widget-pannel #wizard-tab').each( function (key,value){
                                $(this).find('div').removeClass('active')
                                
                                if($(this).find('#confirmed')){
                                    $(this).find('#confirmed').addClass('active')
                                }
                            })
                        }
                    }
                }

                var prr = '';

                function kivicarePrintContent(id) {
                    get('get_appointment_print', {id: id}, true)
                        .then((response) => {
                            if (response.data.status !== undefined && response.data.status === true) {
                                prr = response.data.data;
                                // document.body.innerHTML = prr;
                            }
                        })
                        .catch((error) => {
                            console.log(error);

                        })
                }

                $(document).on('click','#kivicare_print_detail', function(){
                    $( prr ).printArea( {} );
                })

                function kivicareCustomFieldsData(ele){
                    var custom_fields = { };
                    $.each($('#'+ele).find('select, textarea, :input:not(:checkbox)').serializeArray(), function() {
                        custom_fields[this.name] = this.value;
                    });
                    var temp = [];
                    var temp2= '';
                    $.each($('#'+ele).find(':input:checkbox').serializeArray(), function(key,value) {
                        if(temp2 !== value.name){
                            temp = [];
                        }
                        temp.push(value.value)
                        custom_fields[value.name] = temp;
                        temp2 = value.name;
                    });
                    return custom_fields;
                }

            })(window.jQuery)
        }
    })
</script>