<?php

namespace App\controllers;

use App\baseClasses\KCBase;
use App\baseClasses\KCRequest;
use App\models\KCAppointment;
use App\models\KCBillItem;
use App\models\KCClinicSession;
use App\models\KCClinic;
use App\models\KCPatientEncounter;
use App\models\KCAppointmentServiceMapping;

use Exception;

class KCBookAppointmentWidgetController extends KCBase {

	public $db;

	private $request;

	public function __construct() {

		global $wpdb;

		$this->db = $wpdb;

		$this->request = new KCRequest();

	}

	public function getDoctors () {
		$request_data = $this->request->getInputs();
		$doctor_role = $this->getDoctorRole();
		$table_name = $this->db->prefix . 'kc_doctor_clinic_mappings';
        $prefix = '';
        $postfix = '';
		
		$request_data['clinic_id'] =  kcRecursiveSanitizeTextField(json_decode( stripslashes( $request_data['clinic_id']), true));

		if(isset($request_data['clinic_id']['id'])  && !empty($request_data['clinic_id']['id']) ){

            $request_data['clinic_id']['id'] = (int)$request_data['clinic_id']['id'];
            $doctor_condition = ' ';
            if(!empty($request_data['props_doctor_id']) && !in_array($request_data['props_doctor_id'],[0,'0'])){
                if(strpos($request_data['props_doctor_id'], ',') !== false){
                    $request_data['props_doctor_id'] = implode( ',',array_map('absint', explode(',', sanitize_text_field($request_data['props_doctor_id']))));
                    if(isKiviCareProActive()){
                        $doctor_condition = ' AND doctor_id IN ('.$request_data['props_doctor_id'].')';
                    }else{
                        $doctor_condition = ' WHERE ID IN ('.$request_data['props_doctor_id'].')';
                    }
                }else{
                    if(isKiviCareProActive()){
                        $doctor_condition = ' AND doctor_id ='.(int)$request_data['props_doctor_id'];
                    }else{
                        $doctor_condition = ' WHERE ID ='.(int)$request_data['props_doctor_id'];
                    }
                }
            }
            if(!empty($request_data['props_clinic_id']) && !in_array($request_data['props_clinic_id'],[0,'0'])){
                $request_data['clinic_id']['id'] = (int)$request_data['props_clinic_id'];
            }

            if(isKiviCareProActive()){
                $query = "SELECT `doctor_id` FROM {$table_name} WHERE `clinic_id` =".$request_data['clinic_id']['id'].$doctor_condition ;
            }else{
                $query = "SELECT `ID` FROM {$this->db->base_prefix}users {$doctor_condition}" ;
            }

            if(isKiviCareProActive()){
                $result = collect($this->db->get_results($query))->unique('doctor_id')->pluck('doctor_id');
            }else{
                $result = collect($this->db->get_results($query))->unique('ID')->pluck('ID');
            }

			$users = get_users([ 'role' => $doctor_role ,'user_status' => '0']);
			$users = collect($users)->whereIn('ID',$result)->values();
            $prefix_postfix = $this->db->get_var('select extra from '.$this->db->prefix.'kc_clinics where id='.$request_data['clinic_id']['id']);
		    if($prefix_postfix != null){
                $prefix_postfix = json_decode( $prefix_postfix);
                $prefix = isset($prefix_postfix->currency_prefix) ? $prefix_postfix->currency_prefix : '';
                $postfix = isset($prefix_postfix->currency_postfix) ? $prefix_postfix->currency_postfix : '';
            }
        }
		$results = [];
		if (!empty($users) && count($users) > 0) {
			foreach ($users as $key => $user) {
				$image_attachment_id = get_user_meta($user->ID,'doctor_profile_image',true);
				$user_image_url = wp_get_attachment_url($image_attachment_id);
				$results[$key]['id'] = $user->ID;
				$results[$key]['display_name'] = $user->data->display_name;
				$user_data = get_user_meta($user->ID, 'basic_data', true);
				if ($user_data) {
					$user_data = json_decode($user_data);
					$results[$key]['description'] = get_user_meta($user->ID, 'doctor_description', true);
					$results[$key]['address'] = isset($user_data->address) ? $user_data->address : "";
					$results[$key]['city'] = isset($user_data->city) ? $user_data->city : "";
					$results[$key]['state'] = isset($user_data->state) ? $user_data->state : "";
					$results[$key]['country'] = isset($user_data->country) ? $user_data->country : "";
                    $results[$key]['currency'] = '';
					$results[$key]['postal_code'] = isset($user_data->postal_code) ? $user_data->postal_code : "";
					$results[$key]['timeSlot'] = isset($user_data->time_slot) ? $user_data->time_slot : "";
					$results[$key]['price'] = isset($user_data->price) ? $user_data->price : "";
					$results[$key]['gender'] = isset($user_data->gender) ? $user_data->gender : "";
					$results[$key]['qualifications'] = isset($user_data->qualifications) ? $user_data->qualifications : "";
					$results[$key]['specialties'] = isset($user_data->specialties) ? $user_data->specialties : [];
					$results[$key]['enableTeleMed'] = false;
					$results[$key]['custom_fields'] = kcGetCustomFields('appointment_module', $user->ID);
					$results[$key]['user_profile'] =$user_image_url;
                    $results[$key]['contact_no'] = !empty($user_data->mobile_number) ? $user_data->mobile_number : '';
                    $results[$key]['dob'] = !empty($user_data->dob) ? $user_data->dob : '';
                    $results[$key]['specialties_all'] = !empty($user_data->specialties) &&  is_array($user_data->specialties)? collect($user_data->specialties)->pluck('label')->implode(',') : [];
                    $results[$key]['full_address'] = (!empty($user_data->address) ? $user_data->address : "").','.(!empty($user_data->city) ? $user_data->city : '').','.
                        (!empty($user_data->state) ? $user_data->state : "").','.(!empty($user_data->country) ? $user_data->country : "");
					if (is_plugin_active($this->teleMedAddOnName())) { 

						$zoom_config_data = get_user_meta($user->ID, 'zoom_config_data', true);

						if ($zoom_config_data) {

							$zoom_config_data = json_decode($zoom_config_data);

							$enableTeleMed = false;

							if (isset($zoom_config_data->enableTeleMed) && (bool)$zoom_config_data->enableTeleMed) {
								if ($zoom_config_data->api_key !== "" && $zoom_config_data->api_secret !== "") {
									$results[$key]['enableTeleMed'] = true;
								}
							}
							
						}
					}
				}
			}
			echo json_encode([
				'status' => true,
				'message' => __('Doctor details', 'kc-lang'),
				'data' => $results,
                'prefix' => $prefix,
                'postfix' =>$postfix ,
			]);
		}else{
			echo json_encode([
				'status' => false,
				'message' => __('Doctor details', 'kc-lang'),
				'data' => []
			]);
		}

		

	}
	public function getClinic () {
        $response = apply_filters('kcpro_get_clinic_data',['data' => $this->request->getInputs()]);
        echo json_encode($response);
	}

	public function getTimeSlots() {

		$formData = $this->request->getInputs();;

		$timeSlots = kvGetTimeSlots([
			'date' => $formData['date'],
			'doctor_id' => $formData['doctor_id'],
			'clinic_id' => $formData['clinic_id']
		], "", true);
        $htmldata = '';
		if (count($timeSlots)) {
			$status = true;
			$message = __('Time slots', 'kc-lang' );
            if(!empty($formData['widgetType']) && $formData['widgetType'] === 'phpWidget'){
                ob_start();
                foreach ($timeSlots as $sessions){
                    foreach ($sessions as $time_slot){
                        ?>
                        <div class="iq-client-widget iq-time-slot">
                            <input type="radio" class="card-checkbox selected-time" name="card_main" id="time_slot_<?php echo esc_html($time_slot['time']); ?>" value="<?php echo esc_html($time_slot['time']) ; ?>">
                            <label class="iq-button iq-button-white" for="time_slot_<?php echo esc_html($time_slot['time']); ?>">
                                <?php echo esc_html(kcGetAppointmentTimeFormatOption() == 'on' ? date("H:i", strtotime($time_slot['time'])) : $time_slot['time']); ?>
                            </label>
                        </div>
                        <?php
                    }
                }
                $htmldata = ob_get_clean();
            }
		} else {
			$status = false;
			$message = __('Doctor is not available for this date', 'kc-lang' );
		}

		echo json_encode( [
			'status'      => $status,
			'message'     => $message,
			'data'     => $timeSlots,
            'html' => $htmldata
		] );

	}

	public function saveAppointment() {
		global $wpdb;

		$formData = $this->request->getInputs();
        $post_table_name = $wpdb->prefix . 'posts';
		$clinic_session_table = $wpdb->prefix . 'kc_' . 'clinic_sessions';
        $process_status = [];
		$active_domain =$this->getAllActivePlugin();
		
		try {

			if(!is_user_logged_in()) {
				throw new Exception( __('Sign in to book appointment', 'kc-lang'), 401 );
			}

            $clinic_id = isset($formData['clinic_id']['id']) ? $formData['clinic_id']['id']: kcGetDefaultClinicId();
            $clinic_id = (int)$clinic_id;
            $userObj = wp_get_current_user();
			if($active_domain === $this->kiviCareProOnName() &&  $formData['status'] == '1'){
				$args['post_name'] = strtolower(KIVI_CARE_PREFIX.'default_event_template');
				$args['post_type'] = strtolower(KIVI_CARE_PREFIX.'gcal_tmp') ;
			
				$query = "SELECT * FROM $post_table_name WHERE `post_name` = '" . $args['post_name'] . "' AND `post_type` = '".$args['post_type']."' AND post_status = 'publish' ";
				$check_exist_post = $wpdb->get_results($query, ARRAY_A);

                $formData['visit_type'][0]['clinic_id'] = (int)$formData['visit_type'][0]['clinic_id'];
				$clinicData = (new KCClinic())->get_by(['id'=>$formData['visit_type'][0]['clinic_id']] ,'=',true);
				$clinicAddress = $clinicData->address.','.$clinicData->city.','.$clinicData->country;

				$appointment_day = strtolower(date('l', strtotime($formData['appointment_start_date']))) ;
				$day_short = substr($appointment_day, 0, 3);
		
				$query = "SELECT * FROM {$clinic_session_table}  
				WHERE `doctor_id` = ".$formData['doctor_id']['id']." AND `clinic_id` = ".$formData['visit_type'][0]['clinic_id']."  
				AND ( `day` = '{$day_short}' OR `day` = '{$appointment_day}') ";

				$clinic_session = collect($wpdb->get_results($query, OBJECT));
				$time_slot             = isset($clinic_session[0]->time_slot) ? $clinic_session[0]->time_slot : 15;

				$calender_title = $check_exist_post[0]['post_title'];
				$calender_content = $check_exist_post[0]['post_content'];
				
				$key  =  ['{{service_name}}','{{clinic_name}}'];
				foreach($key as $item => $value ){
					switch ($value) {
						case '{{service_name}}':
							$calender_title = str_replace($value, $formData['visit_type'][0]['name'], $calender_title);
							break;
						case '{{clinic_name}}':
							$calender_content = str_replace($value, $clinicData->name, $calender_content);
							break;
					}
				}
				$end_time             = strtotime( "+" . $time_slot . " minutes", strtotime( $formData['appointment_start_time'] ) );
				$appointment_end_time = date( 'H:i:s', $end_time );
				$formData['calender_title'] = $calender_title;
				$formData['calender_content'] = $calender_content;
				$formData['clinic_address'] =$clinicAddress;
				$formData['start'] = date("c", strtotime( $formData['appointment_start_date'].$formData['appointment_start_time']));
				$formData['end'] = date("c", strtotime( $formData['appointment_start_date'].$appointment_end_time));
			}

			if (!in_array($this->getPatientRole(),$userObj->roles)) {
				throw new Exception( __('User must be patient to book appointment', 'kc-lang'), 401 );
			}

            $clinic_session_table = $wpdb->prefix . 'kc_' . 'clinic_sessions';
            $appointment_day = strtolower(date('l', strtotime($formData['appointment_start_time']))) ;
            $day_short = substr($appointment_day, 0, 3);

            $formData['doctor_id']['id'] = (int)$formData['doctor_id']['id'];
            $query = "SELECT * FROM {$clinic_session_table}  WHERE `doctor_id` = ".$formData['doctor_id']['id']." AND `clinic_id` = ".$clinic_id."  AND ( `day` = '{$day_short}' OR `day` = '{$appointment_day}') ";
            $clinic_session = collect($wpdb->get_results($query, OBJECT));
            $time_slot             = isset($clinic_session[0]->time_slot) ? $clinic_session[0]->time_slot : 15;
			$end_time             = strtotime( "+" . $time_slot . " minutes", strtotime( $formData['appointment_start_time'] ) );
			$appointment_end_time = date( 'H:i:s', $end_time );
			$appointment_date     = date( 'Y-m-d', strtotime( $formData['appointment_start_date'] ) );
            $patient_id = get_current_user_id();

			// appointment shortcode condition
            $tempAppointmentData = [
                'appointment_start_date' => $appointment_date,
                'appointment_start_time' => date('H:i:s', strtotime($formData['appointment_start_time'])),
                'appointment_end_date' => $appointment_date,
                'appointment_end_time' => $appointment_end_time,
                'visit_type' => $formData['visit_type'],
                'clinic_id' => $clinic_id,
                'doctor_id' => $formData['doctor_id']['id'],
                'patient_id' => $patient_id,
                'description' => $formData['description'],
                'status' => $formData['status'],
                'created_at' => current_time('Y-m-d H:i:s')
            ];

            if(isset($formData['file']) && is_array($formData['file']) && count($formData['file']) > 0){
                $appointment_table_name = $this->db->prefix . 'kc_appointments';
                kcUpdateFields($appointment_table_name,[ 'appointment_report' => 'longtext NULL']);
                $tempAppointmentData['appointment_report'] = json_encode($formData['file']);
            }

			$patient_appointment_id = (new KCAppointment())->insert($tempAppointmentData);

            $notification = '';
            //send email only if lite plugin is active
            $notification = kivicareCommonSendEmailIfOnlyLitePluginActive($formData,$patient_appointment_id);

            if (gettype($formData['visit_type']) === 'array') {
                foreach ($formData['visit_type'] as $key => $value) {
                    $service = strtolower($value['name']);

                    if ($service == 'telemed') {

                        if ($this->isTeleMedActive() || isKiviCareGoogleMeetActive()) {


                            $formData['appointment_id'] = $patient_appointment_id;
							$formData['time_slot'] = $time_slot;
                            if(kcCheckDoctorTelemedType($patient_appointment_id) == 'googlemeet'){
                                $res_data = apply_filters('kcgm_save_appointment_event',['appoinment_id' => $patient_appointment_id,'service' => kcServiceListFromRequestData($formData)]);
                            }else{
                                $res_data = apply_filters('kct_create_appointment_meeting', $formData);
                            }
                            if(empty($res_data['status'])) {
                                ( new KCAppointmentServiceMapping() )->delete( [ 'appointment_id' =>  (int)$patient_appointment_id] );
                                ( new KCAppointment() )->delete( [ 'id' =>  (int)$patient_appointment_id] );
                                echo json_encode([
                                    'status'  => false,
                                    'message' => __('Video Meeting not generated.', 'kc-lang'),
                                ]); wp_die();
                            }

                            $process_status['telemed']['status'] = false ;
                            $process_status['telemed']['message'] = $res_data['message'];
							// send zoom link
                            if(!empty($res_data) && $res_data['status'] == true) {
                                $telemed_link_send = false;
                                $process_status['telemed']['status'] = true ;
                                $process_status['telemed']['message'] = $res_data['message'];
                                $process_status['telemed']['join_url'] = $res_data['data']['join_url'];
                                if(get_option( KIVI_CARE_PREFIX . 'woocommerce_payment') == false || get_option( KIVI_CARE_PREFIX . 'woocommerce_payment') != 'on') {
                                    if(kcCheckDoctorTelemedType($patient_appointment_id) == 'googlemeet'){
                                        $telemed_link_send = apply_filters('kcgm_save_appointment_event_link_send',['appoinment_id' => $patient_appointment_id]);
                                    }else{
                                        $telemed_link_send = apply_filters('kct_send_zoom_link', ['appointment_id' => $patient_appointment_id ] );;
                                    }

                                }
                                // Email zoom link send status
                                $process_status['telemed']['link_send_status'] = $telemed_link_send ;
                            }
                        }
                    }

                    if($patient_appointment_id) {
                        (new KCAppointmentServiceMapping())->insert([
                            'appointment_id' => (int)$patient_appointment_id,
                            'service_id' => (int)$value['service_id'],
                            'created_at' => current_time('Y-m-d H:i:s'),
							'status' => 1
                        ]);
                    }
                }
                if($active_domain === $this->kiviCareProOnName() || $this->isTeleMedActive() || isKiviCareGoogleMeetActive()){
                    $notification = kcAppointmentSendMailBasedOnWoo($patient_appointment_id,$formData);
                }
            }

            if($patient_appointment_id) {
                $formData['id'] = $patient_appointment_id;
                if (isset($formData['custom_fields']) && $formData['custom_fields'] !== []) {
                    kvSaveCustomFields('appointment_module',$patient_appointment_id, $formData['custom_fields']);
                }
                $message = __('Appointment has been booked successfully', 'kc-lang');
                $status  = true ;
            } else {
                $message = __('Appointment has not been booked', 'kc-lang');
                $status  = false ;
            }

			if ( $formData['status'] === '2' || $formData['status'] === '4' ) {
				KCPatientEncounter::createEncounter( $patient_appointment_id );
                KCBillItem::createAppointmentBillItem($patient_appointment_id );
			}
			
			// woocommerce payment telemed addon
            $woocommerce_response  = kcWoocommerceRedirect($patient_appointment_id, $formData);
            if(!empty($patient_appointment_id) && $patient_appointment_id !== 0) {
                // hook for appointment booked
                do_action( 'kc_appointment_book', $patient_appointment_id );
            }
			if(isset($woocommerce_response['status']) && $woocommerce_response['status']) {
				if(!empty($woocommerce_response['woocommerce_cart_data'])) {
					echo json_encode($woocommerce_response); wp_die();
				}
			}

			echo json_encode([
				'status'      => (bool) $status,
				'message'     => $message,
				'data' 		  => $formData,
                'notification' =>$notification,
			] );

			wp_die();

		} catch ( Exception $e ) {

			$code    = $e->getCode();
			$message = $e->getMessage();

			header( "Status: $code $message" );

			echo json_encode( [
				'status'  => false,
				'message' => $message
			] );
		}

	}

	public function getClinicSelectedArray () {
		$request_data = $this->request->getInputs();

		switch ($request_data['nextStep']){
            case 'doctor':
                $doctor_role = $this->getDoctorRole();
                $table_name = $this->db->prefix . 'kc_doctor_clinic_mappings';
                if(!empty($request_data['clinic_id'])){
                    $clinic_id = (int)$request_data['clinic_id'];
                    $query = "SELECT `doctor_id` FROM {$table_name} WHERE `clinic_id` =".$clinic_id ;
                    $result = collect($this->db->get_results($query))->unique('doctor_id')->pluck('doctor_id');
                    if(!empty($request_data['doctor_id'])){
                        $result= $request_data['doctor_id'];
                    }
                    $users = get_users([ 'role' => $doctor_role ,'user_status' => '0']);
                    $users = collect($users)->whereIn('ID',$result)->values();
                    if(!empty($request_data['searchKey'])){
                        $searchKey = strtolower($request_data['searchKey']);
                        $users = (object)array_filter($users->toArray(),function ($v) use ($searchKey){
                            return strpos(strtolower($v->data->user_email), $searchKey) !== false || strpos(strtolower($v->data->display_name), $searchKey) !== false;;
                        });
                    }
                }else{
                    $query = "SELECT `doctor_id` FROM {$table_name} ";
                    $result = collect($this->db->get_results($query))->unique('doctor_id')->pluck('doctor_id');
                    $users = get_users([ 'role' => $doctor_role,'user_status' => '0' ]);
                    $users = collect($users)->whereIn('ID',$result)->values();
                    if(!empty($request_data['searchKey'])){
                        $searchKey = strtolower($request_data['searchKey']);
                        $users = (object)array_filter($users->toArray(),function ($v) use ($searchKey){
                            return strpos(strtolower($v->data->user_email), $searchKey) !== false || strpos(strtolower($v->data->display_name), $searchKey) !== false;;
                        });
                    }
                }
                $results = [];
                if (count($users) > 0) {
                    foreach ($users as $key => $user) {
                        $image_attachment_id = get_user_meta($user->ID,'doctor_profile_image',true);
                        $user_image_url = wp_get_attachment_url($image_attachment_id);
                        $results[$key]['id'] = $user->ID;
                        $results[$key]['display_name'] = $user->data->display_name;
                        $results[$key]['email'] = $user->data->user_email;
                        $user_data = get_user_meta($user->ID, 'basic_data', true);
                        if ($user_data) {
                            $user_data = json_decode($user_data);
                            $results[$key]['description'] = get_user_meta($user->ID, 'doctor_description', true);
                            $results[$key]['address'] = isset($user_data->address) ? $user_data->address : "";
                            $results[$key]['city'] = isset($user_data->city) ? $user_data->city : "";
                            $results[$key]['state'] = isset($user_data->state) ? $user_data->state : "";
                            $results[$key]['country'] = isset($user_data->country) ? $user_data->country : "";
                            $results[$key]['currency'] = '';
                            $results[$key]['postal_code'] = isset($user_data->postal_code) ? $user_data->postal_code : "";
                            $results[$key]['timeSlot'] = isset($user_data->time_slot) ? $user_data->time_slot : "";
                            $results[$key]['price'] = isset($user_data->price) ? $user_data->price : "";
                            $results[$key]['gender'] = isset($user_data->gender) ? $user_data->gender : "";
                            $results[$key]['qualifications'] = isset($user_data->qualifications) ? $user_data->qualifications : "";
                            $results[$key]['specialties'] = isset($user_data->specialties) ? $user_data->specialties : [];
                            $results[$key]['enableTeleMed'] = false;
                            $results[$key]['custom_fields'] = kcGetCustomFields('appointment_module', $user->ID);
                            $results[$key]['user_profile'] =$user_image_url;
                            $results[$key]['contact_no'] = !empty($user_data->mobile_number) ? $user_data->mobile_number : '';
                            $results[$key]['no_of_experience'] = !empty($user_data->no_of_experience) ? $user_data->no_of_experience : '';
                            $results[$key]['dob'] = !empty($user_data->dob) ? $user_data->dob : '';
                            $results[$key]['specialties_all'] = !empty($user_data->specialties) &&  is_array($user_data->specialties)? collect($user_data->specialties)->pluck('label')->implode(',') : [];
                            $results[$key]['full_address'] = (!empty($user_data->address) ? $user_data->address : "").','.(!empty($user_data->city) ? $user_data->city : '').','.
                                (!empty($user_data->state) ? $user_data->state : "").','.(!empty($user_data->country) ? $user_data->country : "");



                            if (isKiviCareTelemedActive()) {

                                $zoom_config_data = get_user_meta($user->ID, 'zoom_config_data', true);

                                if ($zoom_config_data) {

                                    $zoom_config_data = json_decode($zoom_config_data);
                                    $results[$key]['enableTeleMed'] = $zoom_config_data->enableTeleMed;
                                }
                            }
                        }
                    }
                }

                if(!empty($results)){
                    ob_start();
                    foreach ($results as $doctors){
                        ?><div class="iq-client-widget " data-index="<?php echo esc_html($doctors['id']); ?>">
                        <input type="radio" class="card-checkbox selected-doctor kivicare-doctor-widget" data-index="<?php echo esc_html($doctors['id']); ?>" name="card_main" id="doctor_<?php echo esc_html($doctors['id']); ?>" value="<?php echo esc_html($doctors['id']); ?>" doctorName="<?php echo esc_html($doctors['display_name']); ?>">
                        <label class="btn-border01 w-100" for="doctor_<?php echo esc_html($doctors['id']); ?>">
                            <div class="iq-card iq-card-border iq-fancy-design iq-doctor-widget">
                                <?php
                                    if(kcGetSingleWidgetSetting('showDoctorImage')){
                                ?>
                                    <div class="iq-navbar-header" style="height: 100px;">
                                        <div class="profile-bg"></div>
                                    </div>
                                <?php
                                    }
                                ?>
                                <div class="iq-top-left-ribbon" style="display:<?php echo esc_html($doctors['enableTeleMed'] != 'true' ? 'none' : 'block'); ?>">
                                    <svg xmlns="http://www.w3.org/2000/svg" width="18" viewBox="0 0 20 20" fill="none">
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M13.5807 12.9484C13.6481 14.4752 12.416 15.7662 10.8288 15.8311C10.7119 15.836 5.01274 15.8245 5.01274 15.8245C3.43328 15.9444 2.05094 14.8094 1.92636 13.2884C1.91697 13.1751 1.91953 7.06 1.91953 7.06C1.84956 5.53163 3.08002 4.23733 4.66801 4.16998C4.78661 4.16424 10.4781 4.17491 10.4781 4.17491C12.0653 4.05665 13.4519 5.19984 13.5747 6.72821C13.5833 6.83826 13.5807 12.9484 13.5807 12.9484Z" stroke="white" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"></path>
                                        <path d="M13.5834 8.31621L16.3275 6.07037C17.0075 5.51371 18.0275 5.99871 18.0267 6.87621L18.0167 13.0004C18.0159 13.8779 16.995 14.3587 16.3167 13.802L13.5834 11.5562" stroke="white" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"></path>
                                    </svg>
                                </div>
                                <?php
                                if(kcGetSingleWidgetSetting('showDoctorImage')){
                                    ?><div class="media d-flex justify-content-center align-items-center">
                                    <img src="<?php echo esc_url(!empty($doctors['user_profile']) ? $doctors['user_profile'] : KIVI_CARE_DIR_URI.'/assets/images/kc-demo-img.png'); ?>" class="avatar-90 rounded-circle" alt="<?php echo esc_html($doctors['id']); ?>">
                                    </div>
                                    <?php
                                }

                                ?>
                                <h5 class="mt-2"><?php echo esc_html($doctors['display_name']); ?></h5>
                                <span class="iq-letter-spacing-1 iq-text-uppercase mb-1"><?php echo esc_html($doctors['specialties_all']); ?></span>
                                <?php

                                if(kcGetSingleWidgetSetting('showDoctorExperience')){
                                    $no_of_experience = empty($doctors['no_of_experience']) ? 0 : esc_html($doctors['no_of_experience']);
                                    ?>
                                    <div class="my-2 iq-doctor-badge">
                                        <span class="iq-badge iq-bg-secondary iq-color-white"> <?php echo esc_html__('Exp : ','kc-lang').$no_of_experience; ?> yr</span>
                                    </div>
                                    <?php
                                }
                                $temp = kcGetSingleWidgetSetting('doctorContactDetails');
                                if(!empty($temp->id)){
                                    switch ((int)$temp->id){
                                        case 1:
                                            ?>
                                            <div class="mt-1 d-flex justify-content-evenly gap-1">
                                                <div>
                                                    <h6><?php echo esc_html__('Contact','kc-lang'); ?></h6>
                                                    <p class=""><?php echo esc_html($doctors['contact_no']); ?></p>
                                                </div>
                                                <div>
                                                    <h6><?php echo esc_html__('Email','kc-lang'); ?></h6>
                                                    <p class=""><?php echo esc_html($doctors['email']); ?></p>
                                                </div>
                                            </div>
                                            <?php
                                            break;
                                        case 2:
                                            ?>
                                            <div class="mt-1 d-flex justify-content-evenly gap-1">
                                                <div>
                                                    <h6><?php echo esc_html__('Contact','kc-lang'); ?></h6>
                                                    <p class=""><?php echo esc_html($doctors['contact_no']); ?></p>
                                                </div>
                                            </div>
                                            <?php
                                            break;
                                        case 3:
                                            ?>
                                            <div class="mt-1 d-flex justify-content-evenly gap-1">
                                                <div>
                                                    <h6><?php echo esc_html__('Email','kc-lang'); ?></h6>
                                                    <p class=""><?php echo esc_html($doctors['email']); ?></p>
                                                </div>
                                            </div>
                                            <?php
                                            break;
                                    }
                                }
                                ?>
                            </div>
                        </label>
                        </div>
                        <?php
                    }
                    $htmldata = ob_get_clean();
                    echo json_encode([
                        'status'      => true,
                        'data' 		  => $htmldata
                    ] );

                    wp_die();
                }else{

                    echo json_encode([
                        'status'      => false,
                        'data' 		  => __('No Doctor Available For This Clinic', 'kc-lang'),
                    ] );

                    wp_die();
                }
                break;
            case 'category':
                $service_table     = $this->db->prefix . 'kc_services';
                $service_doctor_mapping  = $this->db->prefix . 'kc_service_doctor_mapping' ;
                $telemedServiceCondition = '';
                if(!isKiviCareTelemedActive()){
                    $telemedServiceCondition = " AND services.type != 'system_service' ";
                }

                $activeService = "SELECT mapping.id AS s_id, mapping.*, services.* FROM {$service_doctor_mapping} AS mapping
					LEFT JOIN {$service_table} AS services ON mapping.service_id = services.id
					WHERE mapping.status = 1 AND services.status = 1 {$telemedServiceCondition}";

                $services = $this->db->get_results($activeService);

                $services = collect( $services );

                if ( ! count( $services )  ) {
                    echo json_encode( [
                        'status'  => false,
                        'data' => __('No services found', 'kc-lang')
                    ] );
                    wp_die();
                }

                $htmldata = kcCreateServiceListHtml($services);

                echo json_encode([
                    'status'      => true,
                    'data' 		  => $htmldata,
                ] );

                wp_die();
                break;
            case 'date-time':
                echo json_encode([
                    'status'      => true,
                    'data' 		  => __('You Selected date-time', 'kc-lang'),
                ] );
                wp_die();
                break;

        }

        echo json_encode([
            'status'      => true,
            'data' 		  => __('No Selection Based Data Found', 'kc-lang'),
        ] );

        wp_die();
	}

    public function getClinicArray(){
        $request_data = $this->request->getInputs();
        $searchKey = esc_sql($request_data['searchKey']);
        if (isKiviCareProActive()) {
            $clinics_table = $this->db->prefix . 'kc_clinics';
            $query = "SELECT * FROM {$clinics_table} WHERE status='1' AND ( name like '%$searchKey%' OR email LIKE '%$searchKey%' OR telephone_no LIKE '%$searchKey%' OR city LIKE '%$searchKey%' OR postal_code LIKE '%$searchKey%')";
            if (!empty($request_data['doctor_id'])) {
                $clinic_doctor_table = $this->db->prefix . 'kc_doctor_clinic_mappings';
                $query_filter_doc = "SELECT clinic_id FROM {$clinic_doctor_table} WHERE doctor_id = " . (int)$request_data['doctor_id'];
                $clinics = $this->db->get_results($query_filter_doc, OBJECT);
            }
            $clinicList = $this->db->get_results($query, OBJECT);
            $res = [];
            foreach ($clinicList as $key => $clinic) {
                $res[$key]['id'] = $clinic->id;
                $res[$key]['name'] = $clinic->name;
                $res[$key]['email'] = $clinic->email;
                $res[$key]['telephone_no'] = $clinic->telephone_no;
                $res[$key]['specialties'] = json_decode($clinic->specialties);
                $res[$key]['address'] = $clinic->address;
                $res[$key]['city'] = $clinic->city;
                $res[$key]['postal_code'] = $clinic->postal_code;
                $res[$key]['country'] = $clinic->country;
                $res[$key]['profile_image'] = wp_get_attachment_url($clinic->profile_image);
            }
            
            if (empty($res)) {
                echo json_encode([
                    'status' => false,
                    'data' => '',
                ]);
            } else {
                ob_start();
                foreach ($res as $clinic) {
                    ?>
                    <div class="iq-client-widget">
                        <input type="radio" class="card-checkbox selected-clinic" name="card_main"
                               id="clinic_<?php echo esc_html($clinic['id']); ?>" value="<?php echo esc_html($clinic['id']); ?>" clinicName="<?php echo esc_html($clinic['name']); ?>"
                               clinicAddress="<?php echo esc_html($clinic['address'] .', '. $clinic['city'] .', '. $clinic['postal_code'] .', '. $clinic['country']); ?>">
                        <label class="btn-border01 w-100" for="clinic_<?php echo esc_html($clinic['id']); ?>">
                            <div class="iq-card iq-card-lg iq-fancy-design iq-card-border">

                                <?php
                                if (kcGetSingleWidgetSetting('showClinicImage')) {
                                    ?>
                                    <div class="d-flex justify-content-center align-items-center">
                                        <img src="<?php echo esc_url(!empty($clinic['profile_image']) ? $clinic['profile_image'] : KIVI_CARE_DIR_URI . '/assets/images/kc-demo-img.png'); ?>"
                                             class="avatar-90 rounded-circle"
                                             alt="<?php echo esc_html($clinic['id']); ?>">
                                    </div>

                                    <?php
                                }
                                ?>
                                <h3 class="kc-clinic-name"><?php echo esc_html($clinic['name']); ?></h3>
                                <?php
                                if (kcGetSingleWidgetSetting('showClinicAddress')) {
                                    ?>
                                    <p class="kc-clinic-address">  <?php echo esc_html($clinic['address'] . ', ' . $clinic['city'] . ', ' . $clinic['postal_code'] . ', ' . $clinic['country']) ?></p>
                                    <?php
                                }
                                $temp = kcGetSingleWidgetSetting('clinicContactDetails');
                                if (!empty($temp->id)) {
                                    switch ((int)$temp->id) {
                                        case 1;
                                            ?>
                                            <hr>
                                            <div class="d-flex justify-content-evenly gap-1">
                                                <div>
                                                    <h6><?php echo esc_html__("Contact", "kc-lang"); ?></h6>
                                                    <p class=""><?php echo esc_html($clinic['telephone_no']); ?></p>
                                                </div>
                                                <div>
                                                    <h6><?php echo esc_html__("Email", "kc-lang"); ?></h6>
                                                    <p class=""><?php echo esc_html($clinic['email']); ?></p>
                                                </div>
                                            </div>
                                            <?php
                                            break;
                                        case 2;
                                            ?>
                                            <hr>
                                            <div class="d-flex justify-content-evenly gap-1">
                                                <div>
                                                    <h6><?php echo esc_html__("Contact", "kc-lang"); ?></h6>
                                                    <p class=""><?php echo esc_html($clinic['telephone_no']); ?></p>
                                                </div>
                                            </div>
                                            <?php
                                            break;
                                        case 3;
                                            ?>
                                            <hr>
                                            <div class="d-flex justify-content-evenly gap-1">
                                                <div>
                                                    <h6><?php echo esc_html__("Email", "kc-lang"); ?></h6>
                                                    <p class=""><?php echo esc_html($clinic['email']); ?></p>
                                                </div>
                                            </div>
                                            <?php
                                            break;
                                    }
                                }
                                ?>
                            </div>
                        </label>
                    </div>
                    <?php
                }
                $htmldata = ob_get_clean();
            }
            echo json_encode([
                'status' => true,
                'data' => $htmldata,
            ]);
            wp_die();
        } else {
            echo json_encode([
                'status' => true,
                'data' => __('Clinic list not available', 'kc-lang'),
            ]);
            wp_die();
        }
    }
    public function appointmentConfirmPage(){
        $request_data = $this->request->getInputs();

        $field_id = 0;
        $label_list = [];
        if(!empty($request_data['custom_field']) && count($request_data['custom_field'])){
            foreach($request_data['custom_field'] as $custom_key => $custom){
                $field_id = str_replace("custom_field_","",$custom_key);
                $query = "SELECT fields FROM {$this->db->prefix}kc_custom_fields WHERE id = {$field_id}";
                $label_list[$custom_key] = collect($this->db->get_results($query))->pluck('fields')->map(function($x) use($custom){
                    return !empty(json_decode($x)->label) ? json_decode($x)->label : '';
                })->toArray();
            }
        }
        
        $request_data['doctor_id'] = (int)$request_data['doctor_id'];
        $doctor_name =  $this->db->get_var("SELECT display_name FROM {$this->db->base_prefix}users WHERE ID = {$request_data['doctor_id']}");
        $request_data['service_list'] = implode(",",array_map('absint',$request_data['service_list']));
        $patient_id = (int)get_current_user_id();
        $patient_data = $this->db->get_row("SELECT * FROM {$this->db->base_prefix}users WHERE ID = {$patient_id}");
        $clinic_currency_detail = kcGetClinicCurrenyPrefixAndPostfix();
        $patient_basic_data = json_decode(get_user_meta($patient_id,'basic_data',true));

        $service_list_data = $this->db->get_results("SELECT service.*, doctor_service.charges FROM {$this->db->prefix}kc_services AS service 
                                                        LEFT JOIN {$this->db->prefix}kc_service_doctor_mapping AS doctor_service ON doctor_service.service_id = service.id
                                                        WHERE service.id IN ({$request_data['service_list']} ) AND doctor_service.doctor_id={$request_data['doctor_id']}");

        $name = $address= '';

        if(!isKiviCareProActive()){
            $data =  kcClinicDetail(kcGetDefaultClinicId());
        }else{
            $data =  kcClinicDetail((int)$request_data['clinic_id']);
        }

        if(!empty($data)){
            $name = $data->name;
            $address = $data->address .', '. $data->postal_code .', '. $data->city .', '. $data->country;
        }
        ob_start();
        ?>
        <div class="kivi-col-6 pr-4">
            <div class="kc-confirmation-info-section">
                <h6 class="iq-text-uppercase iq-color-secondary iq-letter-spacing-1 mb-2"><?php echo esc_html__('Clinic info', 'kc-lang'); ?></h6>
                <div class="iq-card iq-preview-details">
                <table class="iq-table-border mb-0" style="border:0;">
                        <tr>
                            <td>
                                <h6 style="width: 15em;"><?php echo esc_html($name);?></h6>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <p style="width: 15em;"><?php echo esc_html(!empty($address) ? $address : '');?></p>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
            <div class="kc-confirmation-info-section">
                <h6 class="iq-text-uppercase iq-color-secondary iq-letter-spacing-1 mb-2"><?php echo esc_html__('Patient info', 'kc-lang'); ?></h6>
                <div class="iq-card iq-preview-details kc-patient-info">
                    <table class="iq-table-border mb-0" style="border:0;">
                        <tr>
                            <td>
                                <h6><?php echo esc_html__('Name', 'kc-lang'); ?>:</h6>
                            </td>
                            <td id="patientName">
                                <p><?php echo esc_html(!empty($patient_data->display_name) ? $patient_data->display_name : '');?></p>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <h6><?php echo esc_html__('Number', 'kc-lang'); ?>:</h6>
                            </td>
                            <td id="patientTelephone">
                                <p><?php echo esc_html($patient_basic_data->mobile_number);?></p>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <h6><?php echo esc_html__('Email', 'kc-lang'); ?>:</h6>
                            </td>
                            <td id="patientEmail">
                                <p><?php echo esc_html(!empty($patient_data->user_email) ? $patient_data->user_email : '');?></p>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </div>
        <?php
        ?>
        <div class="item-img-1 kivi-col-6 mb-2 pr-4">
            <h6 class="iq-text-uppercase iq-color-secondary iq-letter-spacing-1"><?php echo esc_html__('Appointment summary', 'kc-lang'); ?></h6>
            <div class="iq-card iq-card-border mt-3">
                <div class="d-flex justify-content-between align-items-center">
                    <p><?php echo esc_html__('Doctor', 'kc-lang'); ?> :</p>
                    <h6 id="doctorname"><?php echo esc_html($doctor_name);?></h6>
                </div>
                <div class="d-flex justify-content-between align-items-center mt-3">
                    <p><?php echo esc_html__('Date ', 'kc-lang'); ?> :</p>
                    <h6><span id="dateOfAppointment"><?php echo esc_html($request_data['date']);?></span></h6>
                </div>
                <div class="d-flex justify-content-between align-items-center mt-3">
                    <p><?php echo esc_html__('Time ', 'kc-lang'); ?> :</p>
                    <h6><span id="timeOfAppointment"><?php echo esc_html(kcGetAppointmentTimeFormatOption() == 'on' ? date("H:i", strtotime($request_data['time'])) : $request_data['time'] );?></span></h6>
                </div>
                <div class="iq-card iq-preview-details mt-4">
                    <h6><?php echo esc_html__('Services', 'kc-lang'); ?></h6>

                    <span id="services_list">
                        <?php
                        if(!empty($service_list_data) && count($service_list_data) > 0){
                            $service_total_charge = array_sum(collect($service_list_data)->pluck('charges')->toArray());
                            foreach($service_list_data as $service_data){
                                ?>
                                <div class="d-flex justify-content-between align-items-center mt-1">
                                <p> <?php echo esc_html($service_data->name);?></p>
                                <h6><?php echo esc_html((!empty($clinic_currency_detail['prefix']) ? $clinic_currency_detail['prefix'] : '').$service_data->charges.(!empty($clinic_currency_detail['postfix']) ? $clinic_currency_detail['postfix'] : '' ));?></h6>
                            </div>
                                <?php
                            }
                        }
                        ?>
                    </span>
                </div>
                <div class="d-flex justify-content-between align-items-center kc-total-price mt-4">
                    <h5><?php echo esc_html__('Total Price', 'kc-lang'); ?></h5>
                    <h5 class="iq-color-primary kc-services-total" id="services_total"> <?php echo esc_html((!empty($clinic_currency_detail['prefix']) ? $clinic_currency_detail['prefix'] : '').$service_total_charge.(!empty($clinic_currency_detail['postfix']) ? $clinic_currency_detail['postfix'] : '' ));?></h5>
                </div>
            </div>
        </div>
        
        <?php 
                    if (kcAppointmentMultiFileUploadEnable() && !empty($request_data['file'])) {
                        $request_data['file'] = array_map('absint',$request_data['file']);
                ?>
        <div class="kivi-col-6 pr-4">
            <h6 class="iq-text-uppercase iq-color-secondary iq-letter-spacing-1"><?php echo esc_html__('Uploaded files', 'kc-lang'); ?></h6>
            <div class="iq-card iq-preview-details mt-3">
                <table class="iq-table-border" style="border: 0;">
                    <?php 
                        foreach ($request_data['file'] as $key => $file){
                    ?>
                        <tr>
                            <td>
                                <a href="<?php echo esc_url(wp_get_attachment_url($file)); ?>" target="_blank" alt="<?php echo esc_html(get_the_title($file));?>">
                                <i class="fas fa-external-link-alt"></i><?php echo ' '.esc_html(get_the_title($file)) ?> 
                                </a>
                            </td>
                        </tr>
                    <?php 
                        }
                    ?>
                </table>
            </div>
        </div>
        <?php 
                    }
                    if (kcCheckExtraTabConditionInAppointmentWidget('description') || !empty($request_data['custom_field'])) {
                ?>
        <div class="kivi-col-6 pr-4">
            <h6 class="iq-text-uppercase iq-color-secondary iq-letter-spacing-1"><?php echo esc_html__('Other info', 'kc-lang'); ?></h6>
            <div class="iq-card iq-preview-details mt-3">
                <table class="iq-table-border" style="border: 0;">
                <?php if(!empty($request_data['description'])){ ?>
                    <tr>
                        <td>
                            <h6><?php echo esc_html__('Description', 'kc-lang'); ?>:</h6>
                        </td>
                        <td id="AppointmentDescription">
                            <?php echo esc_html(!empty($request_data['description']) ? $request_data['description'] : '');?>
                        </td>
                    </tr>
                <?php 
                }
                if(!empty($label_list)){
                    foreach($label_list as $label_key => $label_value){
                        if(!empty($request_data['custom_field'][$label_key])){
                            $request_data['custom_field'][$label_key] = is_array($request_data['custom_field'][$label_key])
                                ? implode(', ',$request_data['custom_field'][$label_key]):$request_data['custom_field'][$label_key];
                ?>  
                    <tr>
                        <td>
                            <h6><?php echo esc_html($label_value[0], 'kc-lang'); ?>:</h6>
                        </td>
                        <td>
                            <?php echo esc_html(!empty($request_data['custom_field'][$label_key]) ? $request_data['custom_field'][$label_key] : '');?>
                        </td>
                    </tr>
                <?php
                        }
                    } 
                }
                ?>
                </table>
            </div>
        </div>
        <?php
        }

        $htmldata = ob_get_clean();

        echo json_encode([
            'status' => true,
            'message' => __('confirm page details', 'kc-lang'),
            'data' => $htmldata
        ]);
        wp_die();
    }

    public function getAppointmentPrint(){
        $request_data = $this->request->getInputs();
        $patient_appointment_table = $this->db->prefix . 'kc_appointments';
        $clinics_table           = $this->db->prefix . 'kc_clinics';
        $users_table             = $this->db->base_prefix . 'users';

        if(empty($request_data['id'])){
            echo json_encode([
                'data' => '',
                'status' => false
            ]);
            die;
        }
        $appointment_id = (int)$request_data['id'];
        $query = "SELECT {$patient_appointment_table}.*,
                       doctors.display_name  AS doctor_name,
                       doctors.user_email AS doctor_email,    
                       patients.display_name AS patient_name,
                       patients.user_email AS patient_email,
                       {$clinics_table}.* 
                    FROM  {$patient_appointment_table}
                       LEFT JOIN {$users_table} doctors
                              ON {$patient_appointment_table}.doctor_id = doctors.id
                      LEFT JOIN {$users_table} patients
                              ON {$patient_appointment_table}.patient_id = patients.id
                       LEFT JOIN {$clinics_table}
                              ON {$patient_appointment_table}.clinic_id = {$clinics_table}.id
                    WHERE {$patient_appointment_table}.id = {$appointment_id}";

        $encounter = $this->db->get_row( $query);

        if ( !empty( $encounter ) ) {
            $encounter->medical_history = '';
            $encounter->prescription = '';
            $basic_data = get_user_meta((int)$encounter->doctor_id, 'basic_data', true);
            $basic_data = json_decode($basic_data);
            foreach ($basic_data->qualifications as $q) {
                $qualifications[] = $q->degree;
                $qualifications[] = $q->university;
            }
            $patient_basic_data = json_decode(get_user_meta((int)$encounter->patient_id, 'basic_data', true));
            $encounter->patient_gender = !empty($patient_basic_data->gender)
                ? ($patient_basic_data->gender === 'female'
                    ? 'F' : 'M') : '';
            $encounter->patient_address = (!empty($patient_basic_data->address) ? $patient_basic_data->address : '');
            $encounter->patient_city = (!empty($patient_basic_data->city) ? $patient_basic_data->city : '');
            $encounter->patient_state = (!empty($patient_basic_data->state) ? $patient_basic_data->state : '');
            $encounter->patient_country = (!empty($patient_basic_data->country) ? $patient_basic_data->country : '');
            $encounter->patient_postal_code = (!empty($patient_basic_data->postal_code) ? $patient_basic_data->postal_code : '');
            $encounter->contact_no = (!empty($patient_basic_data->mobile_number) ? $patient_basic_data->mobile_number : '');
            $encounter->patient_add = $encounter->patient_address . ',' . $encounter->patient_city
                . ',' . $encounter->patient_state . ',' . $encounter->patient_country . ',' . $encounter->patient_postal_code;
            $years = $months = $days = 0;
            $encounter->date = current_time('Y-m-d');
            if (!empty($patient_basic_data->dob)) {
                $diff = abs(strtotime(current_time('Y-m-d')) - strtotime($patient_basic_data->dob));
                $years = floor($diff / (365 * 60 * 60 * 24));
                $months = floor(($diff - $years * 365 * 60 * 60 * 24) / (30 * 60 * 60 * 24));
                $days = floor(($diff - $years * 365 * 60 * 60 * 24 - $months * 30 * 60 * 60 * 24) / (60 * 60 * 24)) . esc_html__('Days', 'kc-lang');
                $years = $years . esc_html__(' Years', 'kc-lang');
                $months = $months . esc_html__('Days', 'kc-lang');
            }
            $encounter->patient_age = $years === '0 Years' ? ($months === '0 Months' ? $days : $months) : $years;
            $encounter->qualifications = !empty($qualifications) ? '(' . implode(", ", $qualifications) . ')' : '';
            $encounter->clinic_address = "#{$encounter->clinic_id } ,{$encounter->address } ,{$encounter->city}";
            $default_clinic_log = KIVI_CARE_DIR_URI .'assets/images/kc-demo-img.png';
            $encounter->clinic_logo = !empty($encounter->profile_image) ? wp_get_attachment_url($encounter->profile_image) : $default_clinic_log;
        }

        echo json_encode([
            'data' => kcPrescriptionHtml($encounter,$appointment_id,'appointment'),
            'status' => true
        ]);
        wp_die();
    }

    public function getAppointmentCustomField(){
        $request_data = $this->request->getInputs();
        ob_start();
        kcGetCustomFieldsList('appointment_module',$request_data['doctor_id']);
        $data = ob_get_clean();

        echo json_encode([
            'data' => $data,
            'status' => true
        ]);
        wp_die();
    }
}
